﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.XlsIO;
using System.Data;
using System.Collections;
using System.Reflection;
using System.Web.Script.Serialization;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Data.OleDb;
using System.Data.SqlClient;
using Syncfusion.XlsIO.Implementation;
using Syncfusion.JavaScript.Shared.Serializer;
using Syncfusion.JavaScript.Models;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO.Implementation.Collections;
using System.Configuration;

namespace SpreadsheetAppMVC.Controllers
{
    public class HomeController : Controller
    {
        string connetionString = ConfigurationManager.ConnectionStrings["FileData"].ConnectionString; 
        public ActionResult Index()
        {
            ViewBag.FileNameList = GetDDdata();
            ReadAndUpdateDBData();
            return View();
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult ReadAndUpdateDBData()
        {
            string fileName = "File2.xlsx";
            MemoryStream dataStream = new MemoryStream();
            SqlConnection sqlCon = new SqlConnection(connetionString);
            SqlCommand sqlComm = new SqlCommand("SELECT * FROM [dbo].[Table] WHERE [FileName] = '" + fileName + "'", sqlCon);
            sqlCon.Open();
            SqlDataReader sqlDR = sqlComm.ExecuteReader();
            if (sqlDR.Read())
            {
                dataStream = new MemoryStream((byte[])sqlDR.GetValue(1)); // Get Stream values from DB.
            }
            sqlDR.Close();
            ExcelEngine excelEngine = new ExcelEngine();
            IApplication application = excelEngine.Excel;
            IWorkbook workbook = application.Workbooks.Open(dataStream);
            IWorksheet sheet = workbook.Worksheets[0];
            sheet.Cells[0].Text = "Spreadsheet";   // C# backend edit process by using XlsIo Library.
            MemoryStream newDataStream = new MemoryStream();
            workbook.Version = ExcelVersion.Excel2013;
            workbook.Application.DefaultVersion = ExcelVersion.Excel2013;
            workbook.SaveAs(newDataStream);
            SqlCommand updateComm = new SqlCommand("UPDATE [dbo].[Table] SET FileData=@nFileData WHERE FileName=@nFileName", sqlCon);
            updateComm.CommandTimeout = 0;
            newDataStream.Position = 0;
            byte[] dataBytes = new BinaryReader(newDataStream).ReadBytes(Convert.ToInt32(newDataStream.Length));
            updateComm.Parameters.AddWithValue("@nFileName", fileName);
            updateComm.Parameters.AddWithValue("@nFileData", dataBytes);
            updateComm.ExecuteNonQuery();
            sqlCon.Close();
            return Content("Successfully updated");
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult SaveAndUpdateFileFromDatabase(string fileName, string sheetModel, string sheetData)
        {
            Stream dataStream = Spreadsheet.Save(sheetModel, sheetData, ExportFormat.XLSX, ExcelVersion.Excel2013);
            dataStream.Position = 0;
            byte[] dataBytes = new BinaryReader(dataStream).ReadBytes(Convert.ToInt32(dataStream.Length));
            SqlConnection sqlCon = new SqlConnection(connetionString);
            sqlCon.Open();
            SqlCommand selectComm = new SqlCommand("SELECT * FROM [dbo].[Table] WHERE [FileName] = '" + fileName + "'", sqlCon);
            var hasFileInDB = selectComm.ExecuteScalar();
            if (hasFileInDB == null)
            {
                SqlCommand sqlComm = new SqlCommand("INSERT INTO [dbo].[Table]([FileName], [FileData]) VALUES (@FileName, @FileData)", sqlCon);
                sqlComm.Parameters.AddWithValue("@FileName", fileName);
                sqlComm.Parameters.AddWithValue("@FileData", dataBytes);
                sqlComm.ExecuteNonQuery();
            }
            else
            {
                SqlCommand updateComm = new SqlCommand("UPDATE [dbo].[Table] SET FileData=@nFileData WHERE FileName=@nFileName", sqlCon); // Update edited data to DB.
                updateComm.CommandTimeout = 0;
                updateComm.Parameters.AddWithValue("@nFileName", fileName);
                updateComm.Parameters.AddWithValue("@nFileData", dataBytes);
                updateComm.ExecuteNonQuery();
            }
            sqlCon.Close();
            return Content(fileName);
        }

        //File Open from database
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult OpenFileFromDB(string filename)
        {
            ImportRequest importRequest = new ImportRequest();
            SqlConnection sqlCon = new SqlConnection(connetionString);
            SqlCommand sqlComm = new SqlCommand("SELECT * FROM [dbo].[Table] WHERE [FileName] = '" + filename + "'", sqlCon);
            sqlCon.Open();
            SqlDataReader sqlDR = sqlComm.ExecuteReader();
            if (sqlDR.Read())
            {
                importRequest.FileStream = new MemoryStream((byte[])sqlDR.GetValue(1)); // Get binary values from DB.
            }
            sqlCon.Close();
            return Content(Spreadsheet.Open(importRequest));
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public void ExcelExport(string sheetModel, string sheetData, string password)
        {
            if (String.IsNullOrEmpty(password))
                Spreadsheet.Save(sheetModel, sheetData, "sample", ExportFormat.XLSX, ExcelVersion.Excel2013);
            else
                Spreadsheet.Save(sheetModel, sheetData, "sample", ExportFormat.XLSX, ExcelVersion.Excel2013, password);
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public void CsvExport(string sheetModel, string sheetData)
        {
            Spreadsheet.Save(sheetModel, sheetData, "sample", ExportFormat.CSV);
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public void PdfExport(string sheetModel, string sheetData)
        {
            Spreadsheet.Save(sheetModel, sheetData, "sample", ExportFormat.PDF);
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Import(ImportRequest importRequest)
        {
            return Content(Spreadsheet.Open(importRequest));
        }

        public List<SelectListItem> GetDDdata()
        {
            List<SelectListItem> ddDataSource = new List<SelectListItem>();
            ddDataSource.Add(new SelectListItem() { Text = "", Value = "", Selected = true });
            SqlConnection sqlCon = new SqlConnection(connetionString);
            SqlCommand sqlComm = new SqlCommand("SELECT [FileName] FROM [dbo].[Table]", sqlCon);
            sqlCon.Open();
            SqlDataReader sqlDR = sqlComm.ExecuteReader();
            while (sqlDR.Read())
            {
                var fileName = sqlDR.GetValue(0).ToString();
                ddDataSource.Add(new SelectListItem { Value = fileName, Text = fileName.Replace(".xlsx", "") });
            }
            sqlCon.Close();
            return ddDataSource;
        }
    }
}

